#ifndef CLIB_THXPLAY_PROTOS_H
#define CLIB_THXPLAY_PROTOS_H

/* $VER: thxplay_protos.h 5.2 (11.05.98) */

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif

#ifndef EXEC_TASKS_H
#include <exec/tasks.h>
#endif

/* allocation functions */
ULONG thxInit(APTR module);
void thxFree(void);

/* song control functions */
void thxPlay(void);
void thxStop(void);
void thxPause(void);
void thxWind(ULONG volume);

/* volume control functions */
ULONG thxGetVolume(void);
void thxSetVolume(ULONG volume);

/* multisong support functions */
ULONG thxGetNumSongs(void);
void thxSetSong(ULONG song);

/* noteplay functions */
void thxPlayNote(ULONG channel, ULONG note, ULONG instrument);
void thxStopNote(ULONG channel);
void thxNoteFX(ULONG channel, ULONG effect, ULONG parameter);

/* misc functions */
void thxSignalEnd(struct Task *task, ULONG signalset);
BOOL thxSongEnded(void);
ULONG thxSyncByte(void);
ULONG thxPlaytime(void);

#endif
