#ifndef _INLINE_THXPLAY_H
#define _INLINE_THXPLAY_H

#ifndef __INLINE_MACROS_H
#include <inline/macros.h>
#endif

#ifndef THXPLAY_BASE_NAME
#define THXPLAY_BASE_NAME THXPlayBase
#endif

#define thxInit(module) \
	LP1(0x1E, ULONG, thxInit, APTR, module, a0, \
	, THXPLAY_BASE_NAME)

#define thxFree() \
	LP0NR(0x24, thxFree, \
	, THXPLAY_BASE_NAME)

#define thxPlay() \
	LP0NR(0x2A, thxPlay, \
	, THXPLAY_BASE_NAME)

#define thxStop() \
	LP0NR(0x30, thxStop, \
	, THXPLAY_BASE_NAME)

#define thxPause() \
	LP0NR(0x36, thxPause, \
	, THXPLAY_BASE_NAME)

#define thxWind(direction) \
	LP1NR(0x3C, thxWind, ULONG, direction, d0, \
	, THXPLAY_BASE_NAME)

#define thxGetVolume() \
	LP0(0x42, ULONG, thxGetVolume, \
	, THXPLAY_BASE_NAME)

#define thxSetVolume(volume) \
	LP1NR(0x48, thxSetVolume, ULONG, volume, d0, \
	, THXPLAY_BASE_NAME)

#define thxGetNumSongs() \
	LP0(0x4E, ULONG, thxGetNumSongs, \
	, THXPLAY_BASE_NAME)

#define thxSetSong(song) \
	LP1NR(0x54, thxSetSong, ULONG, song, d0, \
	, THXPLAY_BASE_NAME)

#define thxPlayNote(channel, note, instrument) \
	LP3NR(0x5A, thxPlayNote, ULONG, channel, d0, ULONG, note, d1, ULONG, instrument, d2, \
	, THXPLAY_BASE_NAME)

#define thxStopNote(channel) \
	LP1NR(0x60, thxStopNote, ULONG, channel, d0, \
	, THXPLAY_BASE_NAME)

#define thxNoteFX(channel, effect, parameter) \
	LP3NR(0x66, thxNoteFX, ULONG, channel, d0, ULONG, effect, d1, ULONG, parameter, d2, \
	, THXPLAY_BASE_NAME)

#define thxSignalEnd(task, signalset) \
	LP2NR(0x72, thxSignalEnd, struct Task *, task, a0, ULONG, signalset, d0, \
	, THXPLAY_BASE_NAME)

#define thxSongEnded() \
	LP0(0x78, BOOL, thxSongEnded, \
	, THXPLAY_BASE_NAME)

#define thxSyncByte() \
	LP0(0x7E, ULONG, thxSyncByte, \
	, THXPLAY_BASE_NAME)

#define thxPlaytime() \
	LP0(0x84, ULONG, thxPlaytime, \
	, THXPLAY_BASE_NAME)

#endif /*  _INLINE_THXPLAY_H  */
